diff -ruN qmail-1.03-orig/qmail-smtpd.c qmail-1.03-ldap-20060201-orig/qmail-smtpd.c
--- qmail-1.03-orig/qmail-smtpd.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-smtpd.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,9 +1,12 @@
+#include <unistd.h>
 #include "sig.h"
 #include "readwrite.h"
 #include "stralloc.h"
 #include "substdio.h"
+#include "subfd.h"
 #include "alloc.h"
 #include "auto_qmail.h"
+#include "auto_break.h"
 #include "control.h"
 #include "received.h"
 #include "constmap.h"
@@ -20,72 +23,235 @@
 #include "now.h"
 #include "exit.h"
 #include "rcpthosts.h"
+#include "rbl.h"
 #include "timeoutread.h"
 #include "timeoutwrite.h"
 #include "commands.h"
+#include "dns.h"
+#include "smtpcall.h"
+#include "qmail-ldap.h"
+#include "limit.h"
+#ifdef SMTPEXECCHECK
+#include "execcheck.h"
+#endif
+#ifdef TLS_SMTPD
+#include <openssl/ssl.h>
+SSL *ssl = NULL;
+#endif
+#ifdef DATA_COMPRESS
+/* zlib needs to be after openssl includes or build will fail */
+#include <zlib.h>
+#endif
 
 #define MAXHOPS 100
-unsigned int databytes = 0;
+#define MAXLINELEN 10000
+unsigned long databytes = 0;
 int timeout = 1200;
 
-int safewrite(fd,buf,len) int fd; char *buf; int len;
+#ifdef TLS_SMTPD
+int flagtimedout = 0;
+void sigalrm()
+{
+ flagtimedout = 1;
+}
+int ssl_timeoutread(int tout, int fd, void *buf, int n)
+{
+ int r; int saveerrno;
+ if (flagtimedout) { errno = error_timeout; return -1; }
+ alarm(tout);
+ r = SSL_read(ssl,buf,n);
+ saveerrno = errno;
+ alarm(0);
+ if (flagtimedout) { errno = error_timeout; return -1; }
+ errno = saveerrno;
+ return r;
+}
+int ssl_timeoutwrite(int tout, int fd, const void *buf, int n)
+{
+ int r; int saveerrno;
+ if (flagtimedout) { errno = error_timeout; return -1; }
+ alarm(tout);
+ r = SSL_write(ssl,buf,n);
+ saveerrno = errno;
+ alarm(0);
+ if (flagtimedout) { errno = error_timeout; return -1; }
+ errno = saveerrno;
+ return r;
+}
+#endif
+
+void die_write(void);
+
+int safewrite(int fd, void *buf, int len)
 {
   int r;
+#ifdef TLS_SMTPD
+  if (ssl)
+    r = ssl_timeoutwrite(timeout,fd,buf,len);
+  else
+#endif
   r = timeoutwrite(timeout,fd,buf,len);
-  if (r <= 0) _exit(1);
+  if (r <= 0) die_write();
   return r;
 }
 
 char ssoutbuf[512];
 substdio ssout = SUBSTDIO_FDBUF(safewrite,1,ssoutbuf,sizeof ssoutbuf);
 
-void flush() { substdio_flush(&ssout); }
-void out(s) char *s; { substdio_puts(&ssout,s); }
+void flush(void) { substdio_flush(&ssout); }
+void out(const char *s) { substdio_puts(&ssout,s); }
+
+/* level 0 = no logging
+         1 = fatal errors
+         2 = connection setup and warnings
+         3 = verbose */
+
+int loglevel = 0;
+
+void logpid(int level)
+{
+  char pidstring[FMT_ULONG];
+  if (level > loglevel) return;
+  substdio_puts(subfderr,"qmail-smtpd ");
+  pidstring[fmt_uint(pidstring, getpid())] = 0;
+  substdio_puts(subfderr,pidstring);
+  substdio_puts(subfderr,": ");
+}
+
+void logline(int level, const char *string)
+{
+  if (level > loglevel) return;
+  logpid(level);
+  substdio_puts(subfderr,string);
+  substdio_puts(subfderr,"\n");
+  substdio_flush(subfderr);
+}
+
+void logline2(int level, const char *s1, const char *s2)
+{
+  if (level > loglevel) return;
+  logpid(level);
+  substdio_puts(subfderr,s1);
+  substdio_puts(subfderr,s2);
+  substdio_puts(subfderr,"\n");
+  substdio_flush(subfderr);
+}
+
+void logstring(int level, const char *string)
+{
+  if (level > loglevel) return;
+  substdio_puts(subfderr,string);
+}
+
+void logflush(int level)
+{
+  if (level > loglevel) return;
+  substdio_puts(subfderr,"\n");
+  substdio_flush(subfderr);
+}
 
-void die_read() { _exit(1); }
-void die_alarm() { out("451 timeout (#4.4.2)\r\n"); flush(); _exit(1); }
-void die_nomem() { out("421 out of memory (#4.3.0)\r\n"); flush(); _exit(1); }
-void die_control() { out("421 unable to read controls (#4.3.0)\r\n"); flush(); _exit(1); }
-void die_ipme() { out("421 unable to figure out my IP addresses (#4.3.0)\r\n"); flush(); _exit(1); }
-void straynewline() { out("451 See http://pobox.com/~djb/docs/smtplf.html.\r\n"); flush(); _exit(1); }
-
-void err_bmf() { out("553 sorry, your envelope sender is in my badmailfrom list (#5.7.1)\r\n"); }
-void err_nogateway() { out("553 sorry, that domain isn't in my list of allowed rcpthosts (#5.7.1)\r\n"); }
-void err_unimpl() { out("502 unimplemented (#5.5.1)\r\n"); }
-void err_syntax() { out("555 syntax error (#5.5.4)\r\n"); }
-void err_wantmail() { out("503 MAIL first (#5.5.1)\r\n"); }
-void err_wantrcpt() { out("503 RCPT first (#5.5.1)\r\n"); }
-void err_noop() { out("250 ok\r\n"); }
-void err_vrfy() { out("252 send some mail, i'll try my best\r\n"); }
-void err_qqt() { out("451 qqt failure (#4.3.0)\r\n"); }
+void cleanup(void);
 
+const char *remoteip;
 
+void die_read(void) { logline(1,"read error or connection closed"); cleanup(); _exit(1); }
+void die_write(void) { logline(1,"write error, connection closed"); cleanup(); _exit(1); }
+void die_alarm(void) { out("451 timeout (#4.4.2)\r\n"); logline(1,"connection timed out, closing connection"); flush(); cleanup(); _exit(1); }
+void die_nomem(void) { out("421 out of memory (#4.3.0)\r\n"); logline(1,"out of memory, closing connection"); flush(); cleanup(); _exit(1); }
+void die_control(void) { out("421 unable to read controls (#4.3.0)\r\n"); logline(1,"unable to read controls, closing connection"); flush(); _exit(1); }
+void die_ipme(void) { out("421 unable to figure out my IP addresses (#4.3.0)\r\n"); logline(1,"unable to figure out my IP address, closing connection"); flush(); _exit(1); }
+void straynewline(void) { out("451 See http://pobox.com/~djb/docs/smtplf.html.\r\n"); logline(1,"stray new line detected, closing connection"); flush(); _exit(1); }
+void oversizedline(void) { out("500 Text line too long."); logline(1,"Oversized line in data part, closing connection"); flush(); _exit(1); }
+void err_qqt(void) { out("451 qqt failure (#4.3.0)\r\n"); }
+void err_dns(void) { out("421 DNS temporary failure at return MX check, try again later (#4.3.0)\r\n"); }
+void err_soft(char *s) { out("451 "); out(s); out("\r\n"); logline2(1,"temporary verify error: ", s); }
+void err_bmf(void) { out("553 sorry, your mail was administratively denied. (#5.7.1)\r\n"); }
+void err_bmfunknown(void) { out("553 sorry, your mail from a host ["); out(remoteip); out("] without valid reverse DNS was administratively denied (#5.7.1)\r\n"); }
+void err_maxrcpt(void) { out("553 sorry, too many recipients (#5.7.1)\r\n"); }
+void err_nogateway(void) { out("553 sorry, relaying denied from your location ["); out(remoteip); out("] (#5.7.1)\r\n"); }
+void err_badbounce(void) { out("550 sorry, I don't accept bounce messages with more than one recipient. Go read RFC2821. (#5.7.1)\r\n"); }
+void err_unimpl(const char *arg) { out("502 unimplemented (#5.5.1)\r\n"); logline2(3,"unrecognized command: ",arg); }
+void err_size(void) { out("552 sorry, that message size exceeds my databytes limit (#5.3.4)\r\n"); logline(3,"message denied because: 'SMTP SIZE' too big"); }
+void err_syntax(void) { out("555 syntax error (#5.5.4)\r\n"); }
+void err_relay(void) { out("553 sorry, we don't relay for ["); out(remoteip); out("] (#5.7.1)\r\n"); }
+void err_wantmail(void) { out("503 MAIL first (#5.5.1)\r\n"); logline(4,"'mail from' first"); }
+void err_wantrcpt(void) { out("503 RCPT first (#5.5.1)\r\n"); logline(4,"'rcpt to' first"); }
+
+void err_noop(char *arg) { out("250 ok\r\n"); logline(4,"'noop'"); }
+void err_vrfy(char *arg) { out("252 send some mail, i'll try my best\r\n"); logline2(4,"vrfy for: ",arg); }
+
+void err_rbl(char *arg) { out("553 sorry, your mailserver ["); out(remoteip); out("] is rejected by "); out(arg); out("\r\n"); }
+void err_deny(void) { out("553 sorry, mail from your location ["); out(remoteip); out("] is administratively denied (#5.7.1)\r\n"); }
+void err_badrcptto(void) { out("553 sorry, mail to that recipient is not accepted (#5.7.1)\r\n"); }
+void err_554msg(const char *arg)
+{
+	out("554 "); out(arg); out("\r\n");
+	logline2(3,"message denied: ",arg);
+}
+
+
+stralloc me = {0};
 stralloc greeting = {0};
+stralloc cookie = {0};
 
-void smtp_greet(code) char *code;
+void smtp_greet(const char *code)
 {
   substdio_puts(&ssout,code);
+  substdio_puts(&ssout,me.s);
+  substdio_puts(&ssout," ESMTP ");
   substdio_put(&ssout,greeting.s,greeting.len);
+  if (cookie.len > 0) {
+    substdio_puts(&ssout," ");
+    substdio_put(&ssout,cookie.s,cookie.len);
+  }
+  out("\r\n");
 }
-void smtp_help()
+void smtp_line(const char *code)
 {
-  out("214 qmail home page: http://pobox.com/~djb/qmail.html\r\n");
+  substdio_puts(&ssout,code);
+  substdio_puts(&ssout,me.s);
+  substdio_puts(&ssout," ");
+  substdio_put(&ssout,greeting.s,greeting.len);
+  out("\r\n");
+}
+void smtp_help(char *arg)
+{
+  out("214-qmail home page: http://pobox.com/~djb/qmail.html\r\n");
+  out("214 qmail-ldap patch home page: http://www.nrg4u.com\r\n");
+  logline(4,"help requested");
 }
-void smtp_quit()
+void smtp_quit(char *arg)
 {
-  smtp_greet("221 "); out("\r\n"); flush(); _exit(0);
+  if (!stralloc_copys(&greeting,"Goodbye."))
+    die_nomem();
+  smtp_line("221 ");
+  logline(4,"quit, closing connection");
+  flush();
+  cleanup();
+  _exit(0);
+}
+void err_quit(void)
+{
+  logline(4,"force closing connection");
+  flush();
+  cleanup();
+  _exit(0);
 }
 
-char *remoteip;
-char *remotehost;
-char *remoteinfo;
-char *local;
-char *relayclient;
+const char *remotehost;
+const char *remoteinfo;
+const char *local;
+const char *relayclient;
+const char *relayok;
+const char *greeting550;
+const char *greeting421;
+int  spamflag = 0;
 
 stralloc helohost = {0};
 char *fakehelo; /* pointer into helohost, or 0 */
 
-void dohelo(arg) char *arg; {
+void dohelo(const char *arg)
+{
   if (!stralloc_copys(&helohost,arg)) die_nomem(); 
   if (!stralloc_0(&helohost)) die_nomem(); 
   fakehelo = case_diffs(remotehost,helohost.s) ? helohost.s : 0;
@@ -96,51 +262,224 @@
 int bmfok = 0;
 stralloc bmf = {0};
 struct constmap mapbmf;
+int bmfunknownok = 0;
+stralloc bmfunknown = {0};
+struct constmap mapbmfunknown;
+int rmfok = 0;
+stralloc rmf = {0};
+struct constmap maprmf;
+int brtok = 0;
+stralloc brt = {0};
+struct constmap mapbadrcptto;
+int gmaok = 0;
+stralloc gma = {0};
+struct constmap mapgma;
+int rblok = 0;
+int rbloh = 0;
+int errdisconnect = 0;
+int nobounce = 0;
+int sanitycheck = 0;
+int returnmxcheck = 0;
+int blockrelayprobe = 0;
+unsigned int tarpitcount = 0;
+unsigned int tarpitdelay = 5;
+unsigned int maxrcptcount = 0;
+int sendercheck = 0;
+int rcptcheck = 0;
+int ldapsoftok = 0;
+int flagauth = 0;
+int needauth = 0;
+int needssl = 0;
+int flagauthok = 0;
+const char *authprepend;
+#ifdef TLS_SMTPD
+stralloc sslcert = {0};
+#endif
+char smtpsize[FMT_ULONG];
 
-void setup()
+void setup(void)
 {
-  char *x;
+#ifdef TLS_SMTPD
+  char *sslpath;
+#endif
+  char *x, *l;
   unsigned long u;
- 
+
+  l = env_get("LOGLEVEL");
+  if (l) { scan_ulong(l,&u); loglevel = u > 4 ? 4 : u; }
+
   if (control_init() == -1) die_control();
-  if (control_rldef(&greeting,"control/smtpgreeting",1,(char *) 0) != 1)
+
+  if (control_readline(&me,"control/me") != 1)
+    die_control();
+  if (!stralloc_0(&me)) die_nomem();
+
+  if (control_rldef(&greeting,"control/smtpgreeting", 0, "") == -1)
     die_control();
+
+  if (control_rldef(&cookie,"control/smtpclustercookie", 0, "") == -1)
+    die_control();
+  if (cookie.len > 32) cookie.len = 32;
+
   liphostok = control_rldef(&liphost,"control/localiphost",1,(char *) 0);
   if (liphostok == -1) die_control();
+
   if (control_readint(&timeout,"control/timeoutsmtpd") == -1) die_control();
   if (timeout <= 0) timeout = 1;
 
+#ifdef TLS_SMTPD
+  sslpath = env_get("SSLCERT");
+  if (!sslpath) {
+    sslpath = (char *)"control/smtpcert";
+    if (control_readline(&sslcert, sslpath) == -1)
+      die_control();
+  } else
+    if (!stralloc_copys(&sslcert, sslpath)) die_nomem();
+  if (!stralloc_0(&sslcert)) die_nomem();
+#endif
+
+  x = env_get("TARPITCOUNT");
+  if (x) { scan_ulong(x,&u); tarpitcount = u >= UINT_MAX ? UINT_MAX - 1 : u; }
+
+  x = env_get("TARPITDELAY");
+  if (x) { scan_ulong(x,&u); tarpitdelay = u > INT_MAX ? INT_MAX : u; }
+
+  x = env_get("MAXRCPTCOUNT");
+  if (x) { scan_ulong(x,&u); maxrcptcount = u >= UINT_MAX ? UINT_MAX - 1 : u; };
+
   if (rcpthosts_init() == -1) die_control();
 
   bmfok = control_readfile(&bmf,"control/badmailfrom",0);
   if (bmfok == -1) die_control();
   if (bmfok)
     if (!constmap_init(&mapbmf,bmf.s,bmf.len,0)) die_nomem();
- 
-  if (control_readint(&databytes,"control/databytes") == -1) die_control();
+
+  bmfunknownok = control_readfile(&bmfunknown,"control/badmailfrom-unknown",0);
+  if (bmfunknownok == -1) die_control();
+  if (bmfunknownok)
+    if (!constmap_init(&mapbmfunknown,bmfunknown.s,bmfunknown.len,0))
+      die_nomem();
+
+  rmfok = control_readfile(&rmf,"control/relaymailfrom",0);
+  if (rmfok == -1) die_control();
+  if (rmfok)
+    if (!constmap_init(&maprmf,rmf.s,rmf.len,0)) die_nomem();
+
+  brtok = control_readfile(&brt,"control/badrcptto",0);
+  if (brtok == -1) die_control();
+  if (brtok)
+    if (!constmap_init(&mapbadrcptto,brt.s,brt.len,0)) die_nomem();
+
+  gmaok = control_readfile(&gma,"control/goodmailaddr",0);
+  if (gmaok == -1) die_control();
+  if (gmaok)
+    if (!constmap_init(&mapgma,gma.s,gma.len,0)) die_nomem();
+
+  if (env_get("RBL")) {
+    rblok = rblinit();
+    if (rblok == -1) die_control();
+    if (env_get("RBLONLYHEADER")) rbloh = 1;
+  }
+
+  if (env_get("SMTP550DISCONNECT")) errdisconnect = 1;
+  if (env_get("NOBOUNCE")) nobounce = 1;
+  if (env_get("SANITYCHECK")) sanitycheck = 1;
+  if (env_get("RETURNMXCHECK")) returnmxcheck = 1;
+  if (env_get("BLOCKRELAYPROBE")) blockrelayprobe = 1;
+  if (env_get("SENDERCHECK")) {
+    sendercheck = 1;
+    if (!case_diffs("LOOSE",env_get("SENDERCHECK"))) sendercheck = 2;
+    if (!case_diffs("STRICT",env_get("SENDERCHECK"))) sendercheck = 3;
+  }
+  if (env_get("RCPTCHECK")) rcptcheck = 1;
+  if (env_get("LDAPSOFTOK")) ldapsoftok = 1;
+  greeting550 = env_get("550GREETING");
+  greeting421 = env_get("421GREETING");
+  relayok = relayclient = env_get("RELAYCLIENT");
+
+  if (env_get("SMTPAUTH")) {
+    flagauth = 1;
+    if (!case_diffs("TLSREQUIRED", env_get("SMTPAUTH"))) needssl = 1;
+  }
+  if (env_get("AUTHREQUIRED")) needauth = 1;
+  authprepend = env_get("AUTHPREPEND");
+
+#ifdef SMTPEXECCHECK
+  execcheck_setup();
+#endif
+
+  if (control_readulong(&databytes,"control/databytes") == -1) die_control();
   x = env_get("DATABYTES");
-  if (x) { scan_ulong(x,&u); databytes = u; }
-  if (!(databytes + 1)) --databytes;
+  if (x) scan_ulong(x,&databytes);
+  if (!(databytes + 1)) --databytes; /* poor man overflow detection */
  
   remoteip = env_get("TCPREMOTEIP");
   if (!remoteip) remoteip = "unknown";
-  local = env_get("TCPLOCALHOST");
-  if (!local) local = env_get("TCPLOCALIP");
-  if (!local) local = "unknown";
   remotehost = env_get("TCPREMOTEHOST");
   if (!remotehost) remotehost = "unknown";
   remoteinfo = env_get("TCPREMOTEINFO");
-  relayclient = env_get("RELAYCLIENT");
+
+  local = env_get("TCPLOCALHOST");
+  if (!local) local = env_get("TCPLOCALIP");
+  if (!local) local = "unknown";
+
+  logpid(2);
+  logstring(2,"connection from "); logstring(2,remoteip);
+  logstring(2," ("); logstring(2,remotehost);
+  if (remoteinfo) { logstring(2,", "); logstring(2,remoteinfo); }
+  logstring(2,") to "); logstring(2,local);
+  logflush(2);
+
+  logpid(3);
+  logstring(3, "enabled options: ");
+  if (databytes != 0) {
+    smtpsize[fmt_ulong(smtpsize, databytes)] = 0;
+    logstring(3,"max msg size: ");
+    logstring(3,smtpsize);
+    logstring(3," ");
+  }
+  if (greeting550) logstring(3,"greeting550 ");
+#ifdef TLS_SMTPD
+  if (sslcert.s && *sslcert.s) logstring(3, "starttls ");
+#endif
+  if (relayclient) logstring(3,"relayclient ");
+  if (sanitycheck) logstring(3,"sanitycheck ");
+  if (returnmxcheck) logstring(3,"returnmxcheck ");
+  if (blockrelayprobe) logstring(3,"blockrelayprobe ");
+  if (nobounce) logstring(3,"nobounce ");
+  if (rblok) logstring(3,"rblcheck ");
+  if (rbloh) logstring(3,"rblonlyheader ");
+  if (sendercheck) logstring(3,"sendercheck");
+  if (sendercheck == 1) logstring(3," ");
+  if (sendercheck == 2) logstring(3,"-loose ");
+  if (sendercheck == 3) logstring(3,"-strict ");
+  if (rcptcheck) logstring(3,"rcptcheck ");
+  if (ldapsoftok) logstring(3,"ldapsoftok ");
+  if (flagauth) logstring(3, "smtp-auth");
+  if (needssl) logstring(3, "-tls-required ");
+  else logstring(3, " ");
+  if (needauth) logstring(3, "authrequired ");
+#ifdef SMTPEXECCHECK
+  if (execcheck_on()) logstring(3, "rejectexecutables ");
+#endif
+  if (errdisconnect) logstring(3,"smtp550disconnect ");
+#ifdef ALTQUEUE
+  if (env_get("QMAILQUEUE")) {
+    logstring(3,"qmailqueue ");
+    logstring(3,env_get("QMAILQUEUE"));
+  }
+#endif
+  logflush(3);
+
   dohelo(remotehost);
 }
 
 
 stralloc addr = {0}; /* will be 0-terminated, if addrparse returns 1 */
 
-int addrparse(arg)
-char *arg;
+int addrparse(char *arg)
 {
-  int i;
+  unsigned int i;
   char ch;
   char terminator;
   struct ip_address ip;
@@ -155,6 +494,7 @@
     terminator = ' ';
     arg += str_chr(arg,':');
     if (*arg == ':') ++arg;
+    if (*arg == '\0') return 0;
     while (*arg == ' ') ++arg;
   }
 
@@ -164,7 +504,7 @@
   if (!stralloc_copys(&addr,"")) die_nomem();
   flagesc = 0;
   flagquoted = 0;
-  for (i = 0;ch = arg[i];++i) { /* copy arg to addr, stripping quotes */
+  for (i = 0;(ch = arg[i]);++i) { /* copy arg to addr, stripping quotes */
     if (flagesc) {
       if (!stralloc_append(&addr,&ch)) die_nomem();
       flagesc = 0;
